package compbio.beans;

import java.util.LinkedHashMap;
import java.util.Map;

import compbio.cassandra.PredictionIndex;

public class JobBean implements PredictionIndex {
	private String jobid;
	private String dateStart;
	private String dateEnd;
	private String sequence;
	private String ip;
	private String ProgramName;
	private String ProgramVersion;
	private String ProgramLink;
	private LinkedHashMap<String, String> predictions;

	public JobBean(String seq, String id, String dateStart, String dateEnd, String ip, Map<String, String> pred) {
		this.sequence = seq;
		this.ProgramName = "";
		this.ProgramVersion = "";
		this.jobid = id;
		this.dateStart = dateStart;
		this.dateEnd = dateEnd;
		this.ip = ip;
		this.ProgramLink = "";
		this.predictions = new LinkedHashMap<String, String>();
		setPredictions(pred);
	}

	public void setPredictions(Map<String, String> pred) {
		if (predictions == null)
			predictions = new LinkedHashMap<String, String>();
		for (String index : predIndex) {
			this.predictions.put(index, pred.get(index));
		}
	}

	public String getSequence() {
		return sequence;
	}

	public String getJobid() {
		return jobid;
	}

	public String getDateStart() {
		return dateStart;
	}

	public String getDateEnd() {
		return dateEnd;
	}

	public String getIp() {
		return ip;
	}
	
	public String getProgramName() {
		return ProgramName;
	}
	
	public String getProgramVersion() {
		return ProgramVersion;
	}

	public String getProgramLink() {
		return ProgramLink;
	}

	public void setProgramName(String name) {
		ProgramName = name;
	}
	
	public void setProgramVersion(String version) {
		ProgramVersion = version;
	}
	
	public void setProgramLink(String link) {
		ProgramLink = link;
	}
	
	public Map<String, String> getPrediction() {
		return predictions;
	}
}
