package compbio.cassandra.readers;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.datastax.driver.core.ResultSet;
import com.datastax.driver.core.Row;

import compbio.beans.UserBean;

public class IpReader extends CassandraReader {

	public IpReader() {
		super();
	}

	/**
	 * query jobs by ip
	 * 
	 * @param ip
	 * 
	 * @return UserBean to the controller IPDataController
	 **/
	public UserBean readIp(String ip) {
		ResultSet results = CassandraQuery("SELECT JobID, Protein, FinalStatus, DataBegin FROM ProteinLog WHERE ip = '" + ip + "';");
		if (results.isExhausted())
			return null;
		List<Row> rows = results.all();
		Map<String, String[]> res = new HashMap<String, String[]>();
		for (Row r : rows) {
			if (r.getString("FinalStatus").equals("OK")) {
				String date = r.getString("DataBegin");
				res.put(r.getString("JobID"), new String[] { date.substring(0, date.indexOf(":")), r.getString("Protein") });
			}
		}
		UserBean query = new UserBean(ip);
		query.setMainInfo(res);
		return query;
	}

}
